package com.flexdms.jsfutils;

import javax.faces.component.UIComponent;
import javax.faces.view.facelets.ComponentConfig;
import javax.faces.view.facelets.ComponentHandler;
import javax.faces.view.facelets.FaceletContext;

/**
 * Component Handler provides customization hook to Component.
 * @author jason
 *
 */
public class ExtendedComponentHandler extends ComponentHandler
{
	
	public ExtendedComponentHandler(ComponentConfig config)
	{
		super(config);
	}

	@Override
	public void onComponentCreated(FaceletContext ctx, UIComponent c,
			UIComponent parent)
	{
		super.onComponentCreated(ctx, c, parent);
		if (c instanceof ExtendedComponent)
		{
			ExtendedComponent ec=(ExtendedComponent) c;
			ec.onComponentCreated(ctx, parent);
		}
	}

	@Override
	public void onComponentPopulated(FaceletContext ctx, UIComponent c,
			UIComponent parent)
	{
		super.onComponentPopulated(ctx, c, parent);
		if (c instanceof ExtendedComponent)
		{
			ExtendedComponent ec=(ExtendedComponent) c;
			ec.onComponentPopulated(ctx, parent);
		}
	}
}
