package com.flexdms.jsfutils;

import java.io.Serializable;

import javax.el.MethodExpression;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.event.AbortProcessingException;
import javax.faces.event.AjaxBehaviorEvent;
import javax.faces.event.AjaxBehaviorListener;
import javax.faces.event.ValueChangeEvent;
import javax.faces.event.ValueChangeListener;

public class MethodExpressionListener implements AjaxBehaviorListener, Serializable, ValueChangeListener
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	String method;

	public MethodExpressionListener(String methodExpression)
	{
		method = methodExpression;
	}

	@Override
	public void processAjaxBehavior(AjaxBehaviorEvent event)
			throws AbortProcessingException
	{

		try
		{
			UIComponent component = event.getComponent();
			FacesContext fc = FacesContext.getCurrentInstance();
			MethodExpression me = fc
					.getApplication()
					.getExpressionFactory()
					.createMethodExpression(fc.getELContext(), method, null,
							new Class<?>[] { AjaxBehaviorEvent.class });
			me.invoke(fc.getELContext(), new Object[]{event});
		} catch (Exception e)
		{
			throw new AbortProcessingException(e);
		}
	}
	@Override
	public void processValueChange(ValueChangeEvent event)
			throws AbortProcessingException
	{
		try
		{
			UIComponent component = event.getComponent();
			FacesContext fc = FacesContext.getCurrentInstance();
			MethodExpression me = fc
					.getApplication()
					.getExpressionFactory()
					.createMethodExpression(fc.getELContext(), method, null,
							new Class<?>[] { ValueChangeEvent.class });
			me.invoke(fc.getELContext(), new Object[]{event});
		} catch (Exception e)
		{
			throw new AbortProcessingException(e);
		}
	}

}
