package com.flexdms.jsfutils;

import javax.faces.component.FacesComponent;
import javax.faces.component.UIComponent;
import javax.faces.component.html.HtmlPanelGroup;
import javax.faces.view.facelets.FaceletContext;


/**
 * like ui:include but instead of loading file relative to calling directory
 * load the file from resources
 * @author jason
 *
 */

@FacesComponent(createTag=false, value=ResourceComponent.COMPONENT_TYPE)
public class ResourceComponent extends HtmlPanelGroup implements
		ExtendedComponent
{
	public static final String COMPONENT_TYPE="com.flexdms.jsfutils.resComp";
	public static final String LIBRARY_KEY="library";
	public static final String NAME_KEY="name";
	public static final String CASE_KEY="lowercase";

	@Override
	public void onComponentCreated(FaceletContext ctx, UIComponent parent)
	{
		
	}

	@Override
	public void onComponentPopulated(FaceletContext ctx, UIComponent parent)
	{
		String lib= (String) getAttributes().get(LIBRARY_KEY);
		if (getValueExpression(LIBRARY_KEY)!=null)
		{
			setValueExpression(LIBRARY_KEY, null);
			getAttributes().put(LIBRARY_KEY, lib);
		}
		String name= (String) getAttributes().get(NAME_KEY);
		if (getValueExpression(NAME_KEY)!=null)
		{
			setValueExpression(NAME_KEY, null);
			getAttributes().put(NAME_KEY, name);
		}
		
		String lowercasestr=(String)getAttributes().get(CASE_KEY);
		boolean lowercase=false;
		if (lowercasestr!=null)
		{
			lowercase=Utils.stringToBoolean(lowercasestr, false);
		}
		if (getValueExpression(CASE_KEY)!=null)
		{
			setValueExpression(CASE_KEY, null);
			getAttributes().put(CASE_KEY, String.valueOf(lowercase));
		}
		
		if (lowercase)
		{
			lib=lib.toLowerCase();
			name=name.toLowerCase();
		}
		
		UIComponent comp=FaceletUtils.resouceToComponent(lib+"/"+name);
		getChildren().add(comp);
	}

}
