package com.flexdms.jsfutils;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;

/**
 * Display Zero as empty String
 * @author jason
 *
 */
@FacesConverter(value="zerodouble")
public class ZeroDoubleConverter implements Converter
{

	@Override
	public Object getAsObject(FacesContext context, UIComponent component,
			String value)
	{
		if (value==null)
			return new Double(0);
		else if (value.toString().trim().length()==0)
		{
			return new Double(0);
		} else
		{
			return Double.parseDouble(value.toString().trim());
		}
	}

	@Override
	public String getAsString(FacesContext context, UIComponent component,
			Object value)
	{
		if (value==null)
			return "";
		else if (value instanceof Double)
		{
			Double d=(Double)value;
			if (d==0d)
			{
				return "";
			}
		} else if (value instanceof Integer)
		{
			Integer i=(Integer)value;
			if (i==0)
			{
				return "";
			}
		}
		return value.toString();
	}

}
